#!/bin/sh
LIST_TMP=/tmp/put_list_tmp
PAGE_TMP=/tmp/put_page_tmp
DOWNLOAD_LIST=/tmp/put_download_list
PUT_BASE="http://www.putclub.com"

if [ ! -n "$1" ];then
    URL="http://www.putclub.com/html/course/basic/EnglishUSA/index.html"
else
    URL=$1
fi

BASE_URL="`dirname \"$URL\"`"

get_mp3_url()
{
    url="$1"
    wget -q "$url" -O /tmp/put_mp3 
    iconv -f "GB2312" -t "UTF-8" /tmp/put_mp3 2> /dev/null \
        | grep "<font color=blue>下载音频</font>" \
        | sed -e "s/.*<a href=\"//" \
        -e "s/\"><font.*//"
    rm /tmp/put_mp3
}

get_list_page()
{
    url="$1"
    wget -q "$url" -O "$LIST_TMP"
    iconv -f "GB2312" -t "UTF-8" "$LIST_TMP" -o /tmp/put_iconv
    mv /tmp/put_iconv "$LIST_TMP"
}

get_list()
{
    cat "$LIST_TMP" \
    | grep "/html/course/basic/EnglishUSA/" \
    | grep -E "<span>[0-9]{2}-[0-9]{2}</span>" \
    | sed -e "s/<li><span>[^<]*<\/span><a href=\"//g" \
    -e "s/<\/a><\/li>/\n/g" \
    -e "s/[\t]//g" -e "s/\">/\t/g" \
    -e "s/[\'\"]//g" >> "$DOWNLOAD_LIST"
}

get_all_list()
{
    echo '' > "$DOWNLOAD_LIST"
    get_list
    page="`has_next_page`"
    while [ "$page" != "" ];
    do
        get_list_page "${BASE_URL}/${page}"
        get_list
        page="`has_next_page`"
    done
    
    sed -i -e "/^[\t 
]*$/d" "$DOWNLOAD_LIST"
}

has_next_page()
{
    cat "$LIST_TMP" \
        | grep "下一页</a></li>" \
        | sed -e "s/.*<li><a href='//" \
        -e "s/'>下一页<\/a><\/li>.*//"
}

get_file_name()
{
    file=$1
    echo "${file}.mp3" | sed -e "s/[\\\/|<>\?\*:]//g" -e "s/ /_/g"
}

download_all()
{
    cat "$DOWNLOAD_LIST" | while read line 
    do
        url="${PUT_BASE}`echo \"$line\" | cut -f 1`"
        file="`echo \"$line\" | cut -f 2`"
        save="./`get_file_name \"$file\"`"
        download="`get_mp3_url \"$url\"`"
        echo "----------------------------------------------------"
        echo "文件:${save}"
        echo "地址:${download}"
        if  [ -f "$save" ];then
            echo "已经下载过"
        else
            wget "$download" -O "$save" 
        fi
    done
}

get_list_page "$URL" 
get_all_list
download_all

rm "$LIST_TMP"
rm "$PAGE_TMP"
rm "$DOWNLOAD_LIST"
